
do
	local super=XPRACTICE.Scenario
	XPRACTICE.ANDUIN.Scenario=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.ANDUIN.Scenario
	
	XPRACTICE.ANDUIN.NPCID=181954
	
	local FLOORZ=-0.425*(1.8/3)
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.savedataname="ANDUIN"
		self.npcid=XPRACTICE.ANDUIN.NPCID

		self.phaseinprogress=false
		self.currentphase=1
		self.phasecomplete=false

		self.player=nil
		self.startbutton=nil
		self.lastmovetime=0
		
		self.events={}
		self.stopallevents=false
		
		self.allplayers={}	--TODO: get rid of this -- we get it confused with multiplayer.allplayers
		self.spikes={}
		self.spikedballs={}
		self.spikesrows={}
		
		self.guiddebuffs={}
		self.previousguiddebuffs={}
		self.scenariomode=1		-- 1: randomize, 2: replay, 3: custom
		self.pausemode=false

		self.reportedcollisionlist={}
		
		self.bossqueue={}
		self.bossgcd=0
		self.inphasecount=0
		
		self.blasphemyringeffect=nil
		self.blasphemyoverheadeffect=nil
		self.debuffsactive=false
		
		self.totaldeaths=0
		self.timeelapsed=0
		self.lastreportedtime=0
		self.reportedtimeup=false
		
		self.resultstimer=nil
		self.endtimer=nil
		
		self.owndebuff_prev=nil
		
		self.debufftracker=nil
		
		self.queueloader=nil
	end
	


	function class:Populate()
		super.Populate(self)
		
	
		local scenario=self
		
		self.phaseinprogress=false
		self.phasetime=0
		
		self.buttongroup={}
		self.buttongroup[1]={}		-- Options/Go

		
		self.markers={}
		
	
		local scenario=self
		local gamemenu=XPRACTICE.GameMenu.new()
		gamemenu:Setup(self.game.environment_gameplay,self.game.SCREEN_WIDTH/2-180/2,self.game.SCREEN_HEIGHT/2-270/2)
		self.gamemenu=gamemenu
		

		self.game.environment_gameplay.modelsceneframe:SetLightDirection(.2,0,-1)
		self.game.environment_gameplay.modelsceneframe:SetCameraFarClip(400)
		

		self.collision=XPRACTICE.ANDUIN.Collision.new()
		self.collision.scenario=self
		
		local button

		
		local label=XPRACTICE.FadingLabel.new()		
		label:Setup(self.game.environment_gameplay)
		label.position={x=self.game.SCREEN_WIDTH/2-600/2,y=150,z=0}
		label:SetSize(600,300)
		label:SetText("")
		self.statuslabel=label

		self.debugbuttonx=self.game.SCREEN_WIDTH/2-25
		self.debugbuttony=104

		local label=XPRACTICE.HelpLabel.new()		
		label:Setup(self.game.environment_gameplay)
		--label.position={x=150,y=self.game.SCREEN_HEIGHT/2,z=0}
		label.position={x=150,y=250,z=0}
		label:SetSize(800,600)
		local message="BLASPHEMY\r\r"..
						"Multiple players are required.\r"..
						"Use the BLASPHEMY button to assign random debuffs and start the game.\r"..
						"Find a player with the opposite debuff and run into them before time runs out.  Avoid players with the same debuff.\r"..						
						"You can switch between HEROIC and MYTHIC difficulty.  On MYTHIC, players with no debuff are still dangerous.\r"..
						"Adjust the time limit with the FUSE buttons.\r"..
						"\r"..
						"The other options can help you create and playtest worst-case scenarios.\r"..
						"The REPLAY button will assign repeat debuffs to the same players so you can try again.\r"..
						"Use the PAUSE button to stop and move around freely without resolving the mechanics.\r"..						
						"The SET and CLEAR buttons assign specific debuffs to the player you have targeted in WoW's raidframes.  Use CUSTOM START to activate them."
		--label:SetText("test")
		label:SetText(message)
		label.alpha=0;label.displayobject.drawable:SetAlpha(0)
		self.helplabel=label		
				

		local label=XPRACTICE.LeftAlignedLabel.new()		
		label:Setup(self.game.environment_gameplay)
		label.position={x=self.game.SCREEN_WIDTH-200,y=20,z=0}
		label:SetSize(200,100)
		label:SetText("")
		self.populationlabel=label


		local mob,obj
		local player


		
		--mob=XPRACTICE.Mob.new()
		player=XPRACTICE.PlayerCharacter.new()		
		player:Setup(self.game.environment_gameplay)
		player.displayobject.drawable:SetSheathed(false) 
		
		player.position={x=-15,y=0,z=0}
		player.orientation.yaw=0;player.orientation_displayed.yaw=player.orientation.yaw

		player.scenario=self
		self.player=player		
		tinsert(self.allplayers,player)

		

		self.game.environment_gameplay.cameramanager.camera.focus=player
		self.game.environment_gameplay.cameramanager.camera.orientation.yaw=player.orientation.yaw
		--self.game.environment_gameplay.cameramanager.camera.orientation.pitch=math.pi*0.05
		self.game.environment_gameplay.cameramanager.camera.orientation.pitch=math.pi*0.15
		--self.game.environment_gameplay.cameramanager.camera.cdist=30
		self.game.environment_gameplay.cameramanager.camera.cdist=45
		
		
		local lossofcontrolalert=XPRACTICE.LossOfControlAlert.new()
		self.lossofcontrolalert=lossofcontrolalert
		lossofcontrolalert:Setup(self.game.environment_gameplay)
		lossofcontrolalert.position={x=self.game.SCREEN_WIDTH/2-180/2,y=self.game.SCREEN_HEIGHT/2,z=0}
		lossofcontrolalert.focus=player

		
		--TODO LATER: move elsewhere
		local maincastingbar=XPRACTICE.CastingBar.new()
		self.maincastingbar=maincastingbar
		maincastingbar:Setup(self.game.environment_gameplay)
		maincastingbar.position={x=self.game.SCREEN_WIDTH/2-196/2,y=150,z=0}
		maincastingbar.focus=player
		
		local controller=XPRACTICE.PlayerController.new()
		controller:Setup(self.game.environment_gameplay,player,self.game.environment_gameplay.cameramanager.camera)
		
		
		local debufficon=XPRACTICE.ANDUIN.BlasphemyDebuffIcon.new()
		debufficon:Setup(self.game.environment_gameplay)
		debufficon.position.x=self.game.SCREEN_WIDTH-125
		debufficon.position.y=self.game.SCREEN_HEIGHT-125
		debufficon.scenario=self
		debufficon.focus=self.player
		self.debufficon=debufficon
			
		
		
		self.multiplayer=XPRACTICE.ANDUIN.Multiplayer.new()
		self.multiplayer:Setup(self.npcid,self,self.game.environment_gameplay)	
		self.multiplayer:SendHello()
		
		
		
		
		self.boss=XPRACTICE.ANDUIN.AnduinWrynn.new()
		self.boss.scenario=self
		self.boss:Setup(self.game.environment_gameplay)
		self.boss.position={x=0,y=0,z=0}				
		self.boss:FreezeOrientation(math.pi)
		local nameplate=XPRACTICE.Nameplate.new()
		nameplate.hp_TEMP=0.9
		nameplate:Setup(self.game.environment_gameplay,self.boss)
		nameplate:SetText("Anduin Wrynn")
		local castingbar=XPRACTICE.CastingBarTiny.new()
		castingbar:Setup(self.game.environment_gameplay,0,0,0)
		castingbar.focus=self.boss
		castingbar:AnchorToNameplate(nameplate)
		local mobclickzone=XPRACTICE.MobClickZone.new()
		mobclickzone:Setup(self.game.environment_gameplay,self.boss)
		


		-- we use a separate mob for hidden spells so we can cast while boss is already casting
			-- pick a mob class at random.  we can't use Mob because the game doesn't know how to handle FileID(1) after rebooting
				-- (function crashes silently, no lua error!)
		local obj=XPRACTICE.INDIGNATION.CrimsonCabalist.new()
		obj:Setup(self.game.environment_gameplay)
		obj.alpha=0		-- invisible bunny
		obj.scenario=self
		self.spellbunny=obj
		

		
		-- self.layout=XPRACTICE.ANDUIN.Layout.new()
		-- self.layout:Setup(self.game.environment_gameplay,self)
		
		-- local floorobj
		-- floorobj=XPRACTICE.ANDUIN.Floor.new()
		-- floorobj:Setup(self.game.environment_gameplay)
		-- self.floorobj=floorobj

		local floorobj
		floorobj=XPRACTICE.WoWObject.new()
		floorobj:Setup(self.game.environment_gameplay)		
		--floorobj.displayobject.drawable:SetModelByFileID(1829551)	--8du_nazmirraid_elevator01
		--floorobj.position={x=0,y=0,z=0}
		floorobj.displayobject.drawable:SetModelByFileID(1591934)	--7du_tombofsargeras_councilfloor01
		floorobj.position={x=0,y=0,z=FLOORZ}
		floorobj.scale=1.5
		floorobj.visiblefromallphases=true	
		
		local scenario=self

			
		self.worldmarkercontroller=XPRACTICE.ANDUIN.WorldMarkerController.new()
		self.worldmarkercontroller:Setup(self.game.environment_gameplay)
		
		
		-- self.scheduler=XPRACTICE.ANDUIN.Scheduler.new()
		-- self.scheduler:Setup(self.game.environment_gameplay)
		-- self.scheduler.scenario=self
		
	
	
		XPRACTICE.BossDebugButton.ResetPosition()
		self.bossdebugbuttons={}
		local button
		
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		XPRACTICE.BossDebugButton.debugbuttony=XPRACTICE.BossDebugButton.debugbuttony+52
		--self.getplayerpositionbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.INDIGNATION.Spell_GetPlayerPosition,self.spellbunny)
		
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Help,self.spellbunny,"HELP")
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		
		self.startbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_StartEncounter,self.spellbunny,"BLAS\nPHEMY")	
		-- self.pushbackbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_PushbackMulti,self.spellbunny,"PUSH")
		-- self.tornadoesbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_TornadoesMulti,self.spellbunny,"CYCLO")
		-- --self.tornadoesdebugbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Tornadoes_Debug,self.spellbunny)		
		self.stopbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_StopEncounter,self.spellbunny,"STOP")
		self.stopbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_ReplayEncounter,self.spellbunny,"REPLAY",9)
		
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Heroic,self.spellbunny,"HEROIC",9)
		self.swirlsync2button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Mythic,self.spellbunny,"MYTHIC",9)
		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Fuse6,self.spellbunny,"FUSE\n6 SEC")
		self.swirlsync2button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Fuse8,self.spellbunny,"FUSE\n8 SEC")
		self.swirlsync2button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_FuseX,self.spellbunny,"FUSE\nOFF")
		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		self.dashbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Sprint,self.spellbunny,"DASH")
		self.roarbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Roar,self.spellbunny,"ROAR")
		self.pallybubblebutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_PallyBubble,self.spellbunny,"INVUL\n5 SEC")
		self.brezbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Brez,self.spellbunny,"ANKH")
		
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Pause,self.spellbunny,"PAUSE")
		self.swirlsync2button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Unpause,self.spellbunny,"UNPAUSE",8)
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52		
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Fuse10,self.spellbunny,"FUSE\n10SEC")
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_Fuse12,self.spellbunny,"FUSE\n12SEC")		
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52+52
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Roll,self.player,"ROLL",nil,self.player.combatmodule.spellbook.roll)
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Blink,self.player,"BLINK")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Soulshape,self.player,"SOUL\nSHAPE")		
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_DemonicCircleTeleport,self.player,"LOCK\nTELE")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_TranscendenceTransfer,self.player,"MONK\nTELE")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_LockGateItem,self.player,"GATE\nITEM")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_DoorOfShadows,self.player,"VENTH\nTELE")
		self.hiddentelebutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_DoorOfShadowsTeleport,self.player,"VENTH\nTELE")
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_SetMMB,self.player,"SET\nMMB")
		
		XPRACTICE.BossDebugButton.CarriageReturn()
		
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_CustomEncounter,self.spellbunny,"CUSTOM\nSTART",9)
					-- reverse order because overconfidence is first in-game
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_SetDebuff2,self.spellbunny,"SET")
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_SetDebuff1,self.spellbunny,"SET")
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_ClearDebuff,self.spellbunny,"CLEAR")
		self.swirlsync5button=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.ANDUIN.Spell_ClearAllDebuffs,self.spellbunny,"CLEAR\nALL")
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		XPRACTICE.BossDebugButton.debugbuttonx=XPRACTICE.BossDebugButton.debugbuttonx+52
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_LockGate1,self.player,"GATE1\nSET")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_LockGate2,self.player,"GATE2\nSET")	
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_DemonicCircle,self.player,"LOCK\nSET")
		self.miscbutton=XPRACTICE.BossDebugButton.QuickButton(self.game.environment_gameplay,self,XPRACTICE.Spell_Transcendence,self.player,"MONK\nSET")		
		
		for i=1,#self.bossdebugbuttons do
			self.bossdebugbuttons[i]:SetLockedStartingAlpha(1);self.bossdebugbuttons[i]:EnableMouse(true) --TODO:
		end
		self.hiddentelebutton:SetLockedStartingAlpha(0);self.hiddentelebutton:EnableMouse(false)
		

		self.worldmarkercontroller:LoadAll(self,true)

		
		

		
		if(self.multiplayer.joinedsolo)then
			self.statuslabel:SetText("You are not in a group!\nJoin a group to enable multiplayer features.",nil)
		end
		
		
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		if(self.populationlabel)then
			local playercount=0
			for k,v in pairs(self.multiplayer.allplayers)do
				playercount=playercount+1
			end
			self.populationlabel:SetText("Player count: "..tostring(playercount))
		end
		
		if(self.debuffsactive==true and self.pausemode==false and self.reportedtimeup==false)then
			self.timeelapsed=self.timeelapsed+elapsed
			local timeup=false
			local timelimit=0
			if(self.timeelapsed>=6.0 and XPRACTICE_SAVEDATA.ANDUIN.timelimit=="6")then
				timeup=true
				timelimit=6.0
			elseif(self.timeelapsed>=8.0 and XPRACTICE_SAVEDATA.ANDUIN.timelimit=="8")then
				timeup=true
				timelimit=8.0
			elseif(self.timeelapsed>=10.0 and XPRACTICE_SAVEDATA.ANDUIN.timelimit=="A")then
				timeup=true
				timelimit=10.0
			elseif(self.timeelapsed>=12.0 and XPRACTICE_SAVEDATA.ANDUIN.timelimit=="C")then
				timeup=true
				timelimit=12.0
			end
			if(timeup)then
				self.reportedtimeup=true
				local args={}
				tinsert(args,timelimit)
				self.multiplayer:FormatAndSendCustom("DEAD_TIMEUP",unpack(args))
			end
		end
		
		if(self.player and self.spectating)then
			if(self.player.velocity.x~=0 or self.player.velocity.y~=0 or self.player.velocity.z~=0)then
				self.spectating=false
				self.game.environment_gameplay.cameramanager.camera.focus=self.player
			end
		end
		
		
		--if(self.multiplayer.roomlocked)then
			if(self.multiplayer.host)then
				if(self.bossgcd<=0)then
					if(self.inphasecount>0)then
						if(#self.bossqueue>0)then
							self.bossgcd=self.bossgcd+XPRACTICE.KELTHUZADMULTIPLAYER.Config.BossGCDSafetyBuffer
							local spell=self.bossqueue[1]						
							local spellname="Spell_"..spell
							XPRACTICE.KELTHUZADMULTIPLAYER[spellname]:Broadcast(self)
						end
					end
				end
			end
		--end

		

		--if(self.phaseinprogress)then
		for k,v in pairs(self.multiplayer.allplayers)do
			local player=v
			player.inphase=player.inphase or false 	--TODO: should be true only if quickstart is on
			if(player.inphase)then
				if(player:IsDeadInGame() or not self.multiplayer.roomlocked)then
					player.timeinphase=0
				else
					player.timeinphase=player.timeinphase or 0
					player.timeinphase=player.timeinphase+elapsed
				end
			else			
				player.timeinphase=0
			end
		end
		--end


		if(self.layout and self.player)then
			self.layout:DebugCheck()
		end

		
		---------------------------------------------------------------
		-- HIT DETECTION
		---------------------------------------------------------------
		
		if(self.player)then
			self.collision:OutOfBoundsCheck()
			
			self.collision:DebuffCheck()
		end
		
		-------------------------------------------------------------------------------
		-- GAME END DETECTION
		-------------------------------------------------------------------------------		
		if(self.multiplayer.host)then
			if(self.phaseinprogress and self.debuffsactive and self.pausemode==false)then
				if(self.resultstimer==nil and self.endtimer==nil)then
					local count=0
					for k,v in pairs(self.guiddebuffs) do
						if(v=="1" or v=="2")then
							count=count+1
						end
					end
					if(count==0)then
						self.resultstimer=1.0
					end
				elseif(self.resultstimer~=nil)then
					self.resultstimer=self.resultstimer-elapsed
					if(self.resultstimer<=0)then
						local args={}
						tinsert(args,self.lastreportedtime)
						self.multiplayer:FormatAndSendCustom("RESULTS",unpack(args))
						self.resultstimer=nil
	--					local elapsed=string.format("%01f",self.timeelapsed)
						--self.statuslabel:SetText("Time elapsed: "..elapsed.." sec.  Total deaths: "..self.totaldeaths,5.0)
					end
				elseif(self.endtimer~=nil)then
					local temp=self.endtimer				
					self.endtimer=self.endtimer-elapsed
					if(temp>0 and self.endtimer<=0)then
						self.multiplayer:FormatAndSend("UNLOCK")
					end				
				end
			end
		end
		
		
		------------------------------------------------------------------------------
		-- FAKE COMBAT LOG MESSAGES
		------------------------------------------------------------------------------
		
		if(self.player and self.player.paddedguid)then
			local playerguid=self.player.paddedguid
			local owndebuff=self.guiddebuffs[playerguid]
		
			if(owndebuff~=self.owndebuff_prev)then
				if(owndebuff=="1" or owndebuff=="2")then
					if(self.debuffsactive)then
						if(owndebuff=="1")then
							self.multiplayer:FakeCombatLogMessage("SPELL_AURA_APPLIED "..UnitGUID("player").." 361993")
						elseif(owndebuff=="2")then
							self.multiplayer:FakeCombatLogMessage("SPELL_AURA_APPLIED "..UnitGUID("player").." 361992")					
						end					
						self.owndebuff_prev=owndebuff
					end
				end
				if(owndebuff=="X" or owndebuff==nil)then
					if(self.owndebuff_prev=="1")then
						self.multiplayer:FakeCombatLogMessage("SPELL_AURA_REMOVED "..UnitGUID("player").." 361993")
					elseif(self.owndebuff_prev=="2")then
						self.multiplayer:FakeCombatLogMessage("SPELL_AURA_REMOVED "..UnitGUID("player").." 361992")
					end
					self.owndebuff_prev=owndebuff
				end
			end
		
			
		end
		
		------------------------------------------------------------------------------
		-- MENU BUTTONS
		------------------------------------------------------------------------------	
	
		

		
		
		------------------------------------------------------------------------------
		-- TIMED EVENTS
		------------------------------------------------------------------------------	
		-- process this loop forward so events are executed usually in the order they are queued
		
		for i=1,#self.events do
			local event=self.events[i]
			if(self.stopallevents==false or event.alwayshappens)then
				if(self.game.environment_gameplay.localtime>=event.time)then
					--print("event",event,event.time)
					if(event.button)then
						event.button:BossButtonClick()				
					end
					if(event.func)then
						event.func(self)
					end
					event.dead=true
					--TODO LATER: due to the way spell queues are currently set up, queueing up two buttons on the same frame will overwrite the former spell with the latter
					-- so for now, we break to limit one event per frame
					break
				end
			end
		end

		-- removal loop goes backward as usual
		for i=#self.events,1,-1 do
			if(self.events[i].dead)then
				tremove(self.events,i)
			end
		end
		
	end
	
	
	function class:UpdatePlayerFloorbelowStatus()
	
		for k,v in pairs(self.multiplayer.allplayers)do
			local player=v
			if(self.player.floorbelow==false and self.player.position.z<0)then 
				return 
			end
			local ok=self.collision:EdgeCheck(player)
			player.floorbelow=ok
			
		end
	
		-- --overridden function is base scenario class, so we can't move the entire thing to collision
		-- if(not self.player)then return end
		-- if(not self.player.inphase)then
			-- self.player.floorbelow=true
			-- return
		-- end
		
		-- if(self.player.floorbelow==false and self.player.position.z<0)then 
			-- return 
		-- end
		
		-- local ok=self.collision:EdgeCheck(0)
		-- -- if(ok==false)then	-- this secondary check is only needed for line-based boundary check
			-- -- ok=self.collision:OutOfBoundsCheck(-0.01) or self.collision:OutOfBoundsCheck(-0.01)
		-- -- end
		-- self.player.floorbelow=ok
	end
	


	function class:Brez()
		local auras=self.player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.ANDUIN.Aura_ChangePhaseForced)
		if(#auras>0)then 			
			return 
		end				
		if(self.player.position.z<0)then
			return
		end
	
		local auras=self.player.combatmodule.auras.deadingame
		if(#auras==0)then 
			self.statuslabel:SetText("You're not dead yet.",3.0)
			return 
		end
		local auras=self.player.combatmodule.auras.deadingame
		for i=1,#auras do
			auras[i]:Die()
		end
		
	
		
		self.player.portaldebuff=false
		self.player.velocity.x=0
		self.player.velocity.y=0
		self.player.velocity.z=0				

		self.statuslabel:SetText("Brezzed.",3.0)
		self.multiplayer:FormatAndSendCustom("BREZ")
	end



	-- function class:EnableButtons(buttongroup,toggle)
		-- for i=1,#buttongroup do
			-- local button=buttongroup[i]
			-- if(toggle)then
				-- button.displayobject.drawable:SetAlpha(1)
			-- else
				-- button.displayobject.drawable:SetAlpha(0)
			-- end
			-- button:EnableMouse(toggle)
		-- end
	-- end
	function class:EnableButtons(buttongroup,toggle)
		for i=1,#buttongroup do
			local button=buttongroup[i]
			if(toggle)then
				button.displayobject.drawable:SetAlpha(1) -- for labels
				button.alpha=1
				button:SetLockedStartingAlpha(1.0)	-- for buttons
			else
				button.displayobject.drawable:SetAlpha(0)
				button.alpha=0
				button:SetLockedStartingAlpha(0.0)
			end
			button:EnableMouse(toggle)
		end
	end	
	
	
	function class:DeselectButtons(buttongroup)
		for i=1,#buttongroup do
			local button=buttongroup[i]
			button:Select(false)
		end
	end
	


	function class:ClickButtonAfterDelay(button,delay)		
		if(delay<0)then return end --cheap way to skip events when we fastforward
		local event={}
		event.button=button
		event.time=self.game.environment_gameplay.localtime+delay
		event.dead=false
		tinsert(self.events,event)
	end
	
	function class:FunctionAfterDelay(func,delay)		
		if(delay<0)then return end --cheap way to skip events when we fastforward
		local event={}
		event.func=func
		event.time=self.game.environment_gameplay.localtime+delay
		event.dead=false
		tinsert(self.events,event)
	end
	

	
	function class:OnRoomLock(hostname)
		--self.statuslabel:SetText(hostname.." is starting the encounter, please wait...",3.0)
		self.statuslabel:SetText(hostname.." has started the encounter!",3.0)
		self.phaseinprogress=true
		self.totaldeaths=0
		-- self.multiplayer.sortedguidpointers={}
		-- for k,v in pairs(self.multiplayer.guidpointers)do
			-- tinsert(self.multiplayer.sortedguidpointers,{guid=k,player=v})
		-- end
		-- table.sort(self.multiplayer.sortedguidpointers,function(a,b)return a.guid<b.guid end)

		
		if(self.multiplayer.host)then
			local manager=XPRACTICE.ANDUIN.BlasphemyDebuffManager.new()
			manager:Setup(self.game.environment_gameplay)
			manager.scenario=self
			if(self.scenariomode==1)then
				manager:RandomDebuffs()
			elseif(self.scenariomode==2)then
				manager:ReplayDebuffs()
			elseif(self.scenariomode==3)then
				manager:CustomDebuffs()
			else
				manager:RandomDebuffs()
			end
			self.blasphemydebuffmanager=manager
		end
	end
	
	function class:OnSuccessfulRoleCheck(hostname)
		--self.statuslabel:SetText(hostname.." has started the encounter!",3.0)
		--self.phaseinprogress=true
	end
	
	function class:OnFailedRoleCheck()		
		self.statuslabel:SetText("Could not communicate between all players; please check your ignore lists then restart X Practice.",5.0)
	end	
	
	function class:OnRoomUnlock(hostname,noofficers,acknowledge)
		--if(not self.multiplayer.roomlocked)then return end   --this doesn't work: room is ALREADY unlocked
		
		self:BrezAllPlayers()
		
		if(self.scheduler)then self.scheduler:Deactivate() end
		
		self.debuffsactive=false
		self.guiddebuffs={}
		self.reportedcollisionlist={}
		if(self.blasphemydebuffmanager)then
			self.blasphemydebuffmanager:Die()
		end
		if(self.blasphemyprojectileeffect)then
			self.blasphemyprojectileeffect:Die()
		end
		if(self.blasphemyringeffect)then
			self.blasphemyringeffect:Die()
		end
		if(self.blasphemyoverheadeffect)then
			self.blasphemyoverheadeffect:Die()
		end		
		
		
		
		
		
		if(not self.multiplayer.joinedgameinprogress)then
			if(not noofficers)then
				if(self.phaseinprogress)then
					self.statuslabel:SetText(hostname.." ended the encounter.",3.0)
				end
			else
				if(self.phaseinprogress)then      
					self.statuslabel:SetText("The host has left the room.  The encounter ends.",3.0)
				end
			end					
			self.multiplayer:SendIExist()
		else
			self.multiplayer.joinedgameinprogress=false
			self.statuslabel:SetText("The encounter in progress has ended.  You will now join the room.",3.0)
			self.multiplayer:SendHello()
		end		
		self.totaldeaths=0
		self.timeelapsed=0
		self.reportedtimeup=false
		self.lastreportedtime=0
		self.phaseinprogress=false
		self.resultstimer=nil
		self.endtimer=nil

		

	end

	function class:OnRoomAlreadyInProgress(sender)
		self.statuslabel:SetText("An encounter is already in progress!\nYou will automatically join the room when the encounter ends.",nil)
	end
	
	function class:OnCustomMessage(msgcode,sender,args)
		
	end
	
	function class:OnEscapeKey()
		if(self.gamemenu)then
			if(self.gamemenu.shown)then
				self.gamemenu:Hide()
			else
				local ok=true
				if(self.player)then					
					if(self.player.combatmodule.targetmob)then
						ok=false
					end
				end
				if(ok)then
					self.gamemenu:Show()
				end
			end
		end
	end	
	
	function class:AttemptKillPlayer(player,ignorebubble)
		if(player:IsDeadInGame())then return false end
		--TODO: move to base mob
		for i=1,#player.combatmodule.auras.newauras do
			local aura=player.combatmodule.auras.newauras[i]
			if(aura:Class()==XPRACTICE.Aura_DeadInGame)then return false end
			--print(aura.class)
		end
		
		local auras=player.combatmodule.auras:GetAurasByClassIfExist(XPRACTICE.ANDUIN.Aura_PallyBubble)
		if(#auras>0 and ignorebubble~=true)then
			return false
		else			
			--print("AKP",player,ignorebubble)
			local aura=player.combatmodule:ApplyAuraByClass(XPRACTICE.Aura_DeadInGame,player.combatmodule,player.environment.localtime)	
			self.totaldeaths=self.totaldeaths+1	
			return true
		end
	end
	
	function class:BrezAllPlayers()
		--print("Current?:",self.multiplayer.allplayers)
		for k,v in pairs(self.multiplayer.allplayers) do
			--print("Rez player",k,v)
			local player=v		
			local auras=player.combatmodule.auras.deadingame
			if(#auras>0)then
				for i=1,#auras do
					auras[i]:Die()
				end
				player.ai.targetposition=nil
			end
		end
		for k,v in pairs(self.multiplayer.previousplayerghosts) do
			local player=v		
			local auras=player.combatmodule.auras.deadingame
			if(#auras>0)then
				for i=1,#auras do
					auras[i]:Die()
				end
				player.ai.targetposition=nil			
			end
		end
	end
	
	
	XPRACTICE.ScenarioList.RegisterScenario(XPRACTICE.ANDUIN.Scenario,"Blasphemy","(Anduin Wrynn)","SCENARIO")
	--XPRACTICE.ScenarioList.RegisterScenario(XPRACTICE.ANDUIN.Scenario,"9.2","Selpulcher of the First Ones","SEPARATOR")
end

