do	
	local super=XPRACTICE.Spell
	XPRACTICE.THEJAILER3.Spell_RelentlessDomination=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER3.Spell_RelentlessDomination
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.name="Relentless Domination"
		self.icon="interface/icons/inv_cape_special_domination_c_01.blp"
		self.requiresfacing=false;self.projectileclass=nil;
		self.basecastduration=6.0;
		self.basechannelduration=nil;self.basechannelticks=nil
	end
	
	function class:Broadcast_v2(scenario)
		if(#XPRACTICE.THEJAILER3.TyrannyManager.targets==0)then
			scenario.statuslabel:SetText("Tyranny targets have not been set.  Click ROLL TARGETS first.",5.0)
			return
		end
		local boss=scenario.boss
		scenario.multiplayer:FormatAndSendCustom("BOSS_RELENTLESSDOMINATION",boss.position.x,boss.position.y)
	end
		
	function class:StartCastingEffect(spellinstancepointer)	
		local boss=spellinstancepointer.castercombat.mob
		local scenario=boss.scenario		
		
		--XPRACTICE_RaidBossEmote("LOS",5.0,true)	--TODO NEXT: adjust framelevel so bossemotes are visible again
		
		--boss.animationmodule:ResetAnimation(XPRACTICE.THEJAILER3.AnimationList.Custom11)
		--boss.attachedweapon.animationmodule:ResetAnimation(XPRACTICE.THEJAILER3.AnimationList.Custom11)		
		
		local args=spellinstancepointer.args
		boss.position.x=args[1]
		boss.position.y=args[2]
		
		for i=1,#scenario.allpcs do
			local pc=scenario.allpcs[i]
			if(pc.rolepointer and pc.rolepointer.playerghostpointer)then
				scenario.player.combatmodule:ApplyAuraByClass(XPRACTICE.THEJAILER3.Aura_LOSCountdown,pc.combatmodule,pc.environment.localtime)
			end
		end
	end

	
	function class:CompleteCastingEffect(castendtime,spellinstancepointer)	
		local scenario=spellinstancepointer.castercombat.mob.scenario	
		local boss=spellinstancepointer.castercombat.mob
		local player=scenario.player
		
		if(scenario.player~=boss)then
			local vectorx=boss.position.x-player.position.x
			local vectory=boss.position.y-player.position.y
			local ignoredwalls={}
			local hit,mobangle,wallangle,diff,wallindex=self.scenario.layout:WalllineCheck(player,vectorx,vectory,ignoredwalls)
			if(not hit)then
				if(not player.spectator)then
					scenario.statuslabel:SetText("You were MCed.",3.0)
					scenario:AttemptKillPlayer(player,true)	
					scenario.multiplayer:FormatAndSendCustom("DEAD_LOS_MC")
				else
					scenario.statuslabel:SetText("If you weren't spectating, you would have been MCed.",3.0)
				end
			end
		end
		local projs=XPRACTICE.THEJAILER3.MCProjectileEffect.new()
		projs:Setup(boss.environment)
		projs.scenario=scenario
		for i=1,#scenario.layout.pylonmanager.pylons do
			local pylon=scenario.layout.pylonmanager.pylons[i]
			if(pylon.expectedwallstate==true)then
				--print("Pylon:",i,pylon.wall,pylon.expectedwallstate)
				projs:AddBolt(pylon,i)				
			end
		end
		--TODO NEXT: MC projectile for players too (also in DEAD_LOS_MC)
	end			
	
	do
		local roomnumber=XPRACTICE.THEJAILER3.NPCID
		local roomBCD=XPRACTICE.MULTIPLAYERV2.Datatypes.BCD.ToString(XPRACTICE.THEJAILER3.NPCID)	
		do	
			local messagecode=XPRACTICE.MULTIPLAYERV2.previouscustomcode		
			messagecode=messagecode+1
			local BCDmessagecode=XPRACTICE.MULTIPLAYERV2.Datatypes.ShortBCD.ToString(messagecode)
			local messagename="BOSS_RELENTLESSDOMINATION"
			local super=XPRACTICE.MULTIPLAYERV2.Message
			local lambda=XPRACTICE.inheritsFrom(super)
			local class=lambda	
			function class:SetCustomInfo()
				self.messagename=messagename;self.messagecode=messagecode;self.BCDmessagecode=BCDmessagecode
				self.ignoreself=false
				self.requireofficer=true
				self.argtypes={{XPRACTICE.MULTIPLAYERV2.Datatypes.BCD,4},
								{XPRACTICE.MULTIPLAYERV2.Datatypes.BCD,4}}
			end		
			XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]=lambda.new();XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]:Setup()
			XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].MessagetypesBCDPointer[BCDmessagecode]=XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]									
			XPRACTICE.MULTIPLAYERV2.previouscustomcode=messagecode
		end
		do	
			local messagecode=XPRACTICE.MULTIPLAYERV2.previouscustomcode		
			messagecode=messagecode+1
			local BCDmessagecode=XPRACTICE.MULTIPLAYERV2.Datatypes.ShortBCD.ToString(messagecode)
			local messagename="DEAD_LOS_MC"
			local super=XPRACTICE.MULTIPLAYERV2.Message
			local lambda=XPRACTICE.inheritsFrom(super)
			local class=lambda	
			function class:SetCustomInfo()
				self.messagename=messagename;self.messagecode=messagecode;self.BCDmessagecode=BCDmessagecode
				self.ignoreself=true
				self.requireofficer=false
				self.argtypes={}
			end		
			XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]=lambda.new();XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]:Setup()
			XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].MessagetypesBCDPointer[BCDmessagecode]=XPRACTICE.MULTIPLAYERV2["CUSTOM_"..roomBCD].Messagetypes[messagename]									
			XPRACTICE.MULTIPLAYERV2.previouscustomcode=messagecode
		end		
	end
	
	do	
		local class=XPRACTICE.THEJAILER3.Multiplayer
		function class.HandleCustom_DEAD_LOS_MC(self,sender,args)
			local scenario=self.scenario
			local player=self.allplayers[sender]	
			if(not player)then return end
			if(player:IsDeadInGame())then return end		
			scenario.statuslabel:SetText(sender.." was MCed.",3.0)
			scenario:AttemptKillPlayer(player,true)		
		end			
	end

end


