do
	local super=XPRACTICE.GameObject
	XPRACTICE.THEJAILER3.Layout=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER3.Layout
	

	
	function class:Setup(environment,x,y,z)
		--local DEBUG_VLINES=true
		local DEBUG_VLINES=false
		super.Setup(self,environment,x,y,z)
		self.edgelines={}		
		self.walllines={}		
		self.permanentedgelines={}
		self.innerwalllines={}	-- only when z<0
		self.outerwalllines={}	-- only when z>0 AND pylon is up	
		
		
		-- outer edge
		for i=0,5 do
			local t=i/6*(math.pi*2)+math.pi/2
			local t2=(i+1)/6*(math.pi*2)+math.pi/2			
			local radius=82.75
			local line={}
			line.x1=math.cos(t)*radius
			line.y1=math.sin(t)*radius
			line.x2=math.cos(t2)*radius
			line.y2=math.sin(t2)*radius
			if(line.y1>line.y2)then line.x1,line.y1,line.x2,line.y2=line.x2,line.y2,line.x1,line.y1 end
			tinsert(self.permanentedgelines,line)
		end
		-- inner edge		
		for i=0,5 do
			local t=i/6*(math.pi*2)+math.pi/2
			local t2=(i+1)/6*(math.pi*2)+math.pi/2			
			local radius=13.0
			local line={}
			line.x1=math.cos(t)*radius
			line.y1=math.sin(t)*radius
			line.x2=math.cos(t2)*radius
			line.y2=math.sin(t2)*radius
			if(line.y1>line.y2)then line.x1,line.y1,line.x2,line.y2=line.x2,line.y2,line.x1,line.y1 end
			tinsert(self.permanentedgelines,line)					
		end		
		self.pylonmanager=XPRACTICE.THEJAILER3.PylonManager.new()
		self.pylonmanager.layout=self
		self.pylonmanager.scenario=self.scenario
		self.pylonmanager:Setup(environment)
		
	
		self:RebakeDynamicLines()
		
		if(DEBUG_VLINES)then
			self:ShowDebugLines()
		end
	end
	
	function class:ShowDebugLines()
		--for i=1,#self.edgelines do
--			local line=self.edgelines[i]
		for i=1,#self.walllines do			
			local line=self.walllines[i]

			local vline=XPRACTICE.VisibleLine.new()
			vline:Setup(self.environment,line.x1,line.y1,0.2,line.x2,line.y2,0.2)
			vline:ChangeLineActorID(1363271,0,0);vline.scale=0.25;vline.visible=true				
		end	
	end
	
	function class:RebakeDynamicLines()
		self.edgelines={}	
		for k,v in ipairs(self.permanentedgelines)do
			tinsert(self.edgelines,v)
		end				
		self.walllines={}		
		for j=1,#self.pylonmanager.pylons do
			local pylon=self.pylonmanager.pylons[j]				
			for i=0,5 do
				local t=i/6*(math.pi*2)+math.pi/2
				local t2=(i+1)/6*(math.pi*2)+math.pi/2
				local radius=5.2					
				local hitboxsize=0.5				
				if(true)then
					-- walls on sides of holes below floor
					local line={}
					local wallradius=radius-hitboxsize
					line.x1=pylon.position.x+math.cos(t2)*wallradius
					line.y1=pylon.position.y+math.sin(t2)*wallradius
					line.x2=pylon.position.x+math.cos(t)*wallradius
					line.y2=pylon.position.y+math.sin(t)*wallradius
					-- do not optimize wall lines for edge checks -- direction matters
					line.underground=true
					tinsert(self.walllines,line)
				end
				if(pylon.hole)then
					-- holes in floor					
					local line={}
					line.x1=pylon.position.x+math.cos(t)*radius
					line.y1=pylon.position.y+math.sin(t)*radius
					line.x2=pylon.position.x+math.cos(t2)*radius
					line.y2=pylon.position.y+math.sin(t2)*radius
					if(line.y1>line.y2)then line.x1,line.y1,line.x2,line.y2=line.x2,line.y2,line.x1,line.y1 end					
					tinsert(self.edgelines,line)
				end
				if(pylon.wall)then
					-- -- walls on sides of pylons above floor
					local line={}
					local wallradius=radius+hitboxsize
					local extrawalllength=1/16.0
					line.x1=pylon.position.x+math.cos(t)*wallradius+math.cos(t-math.pi*1/3)*extrawalllength
					line.y1=pylon.position.y+math.sin(t)*wallradius+math.sin(t-math.pi*1/3)*extrawalllength
					line.x2=pylon.position.x+math.cos(t2)*wallradius+math.cos(t2+math.pi*1/3)*extrawalllength
					line.y2=pylon.position.y+math.sin(t2)*wallradius+math.sin(t2+math.pi*1/3)*extrawalllength
					-- do not optimize wall lines for edge checks -- direction matters
					tinsert(self.walllines,line)				
				end
			end
		end	
			
	end
	
	function class:EdgelineCheck(yoffset)
		--TODO: optimize?
		local ok=false
		local x=self.scenario.player.position.x
		local y=self.scenario.player.position.y+yoffset
		for i=1,#self.edgelines do
			local flip=false
			local line=self.edgelines[i]			
			--TODO: dedicated hz line / line intersection function?
			--expect y1 always <= y2
			if(line.y1<y and y<line.y2)then	
				if(line.x1==line.x2)then
					if(x>line.x1)then flip=true end
				else
					local targetx=line.x1+(line.x2-line.x1)*(y-line.y1)/(line.y2-line.y1)
					if(x>targetx)then flip=true end
				end
			end
			if(flip)then
				ok=not ok
			end			
		end
		
		return ok
	end

	
	function class:BakeDynamicWalllines(mob)
		local walllines={}
		if(mob.position.z<0)then
			for k,v in ipairs(self.innerwalllines)do
				tinsert(walllines,v)				
			end
		end
		if(true)then
			for k,v in ipairs(self.outerwalllines)do
				tinsert(walllines,v)
			end	
		end
		self.walllines=walllines
	end
	
	function class:WalllineCheck(mob,vectorx,vectory,ignoredwalls)
		local moblinex1=mob.position.x
		local moblinex2=mob.position.x+vectorx
		local mobliney1=mob.position.y
		local mobliney2=mob.position.y+vectory
		--print("Mob:",moblinex1,mobliney1,moblinex2,mobliney2)
		--print("Walls:",#self.walllines)
		for i=1,#self.walllines do
			if(not ignoredwalls[i])then				
				if(mob.position.z<0 or self.walllines[i].underground~=true)then
					local wline=self.walllines[i]
					if(XPRACTICE.LineLineIntersection(moblinex1,mobliney1,moblinex2,mobliney2,wline.x1,wline.y1,wline.x2,wline.y2))then
						local mobangle=math.atan2(mobliney2-mobliney1,moblinex2-moblinex1)
						local wallangle=math.atan2(wline.y2-wline.y1,wline.x2-wline.x1)								
						local diff=XPRACTICE.AngleDifference(mobangle,wallangle)
						--print("Diff:",diff)
						if(diff>=0)then
							return true,mobangle,wallangle,diff,i
						end
					end
				end
			end
		end

		return false,nil,nil,nil,nil
	end
	
	
	
	
end