
--TODO: floor only appears once after a /reload

function QuatToEuler(qW,qX,qY,qZ)
	--ZYX

			--print("WXYZ:",qW,qX,qY,qZ)
			local r1=2*(qW*qX+qY*qZ)
			local r2=1-2*(qX*qX+qY*qY)
			--local roll=math.atan2(2*(qW*qX+qY*qZ),1-2*(qX*qX+qY*qY))
			local roll=math.atan2(2*(qW*qX+qY*qZ),2*(qW*qW-qX*qX-qY*qY+qZ*qZ))
			local pitch
			if(math.abs(2*(qW*qY-qZ*qX))>=1)then
				pitch=math.pi/2*XPRACTICE.signum(2*(qW*qY-qZ*qX))
			else
				pitch=math.asin(2*(qW*qY-qZ*qX))
			end			
			local yaw=math.atan2(2*(qW*qZ+qX*qY),1-2*(qY*qY+qZ*qZ))			

	return roll,pitch,yaw
end

function EulerToQuat(roll,pitch,yaw)
	--ZYX
    local cy = math.cos(yaw * 0.5);
    local sy = math.sin(yaw * 0.5);
    local cp = math.cos(pitch * 0.5);
    local sp = math.sin(pitch * 0.5);
    local cr = math.cos(roll * 0.5);
    local sr = math.sin(roll * 0.5);

    local w = cr * cp * cy + sr * sp * sy;
    local x = sr * cp * cy - cr * sp * sy;
    local y = cr * sp * cy + sr * cp * sy;
    local z = cr * cp * sy - sr * sp * cy;
	
	return w,x,y,z
end

do

	--local guidefileid=3088259
	local guidefileid=3088249
	local GUIDESCALE=0.02

	do
		local super=XPRACTICE.MultiSolid
		XPRACTICE.THEJAILER2.Floor=XPRACTICE.inheritsFrom(super)
		local class=XPRACTICE.THEJAILER2.Floor
		


		function class:MirrorGuide(x,y)
			self:AddActorCustomViaFileID(guidefileid,x,y,0,GUIDESCALE)
			self:AddActorCustomViaFileID(guidefileid,x,self.mirrory-y,0,GUIDESCALE)			
		end
		
		function class:RotateGuide(x,y)
			for i=0,self.rotatecount do
				local t=i*math.pi*2/6
				local x2,y2=XPRACTICE.Transform_Rotate2D(x,y,t,0,0)
				self:AddActorCustomViaFileID(guidefileid,x2,y2,0,GUIDESCALE)
			end
		end		


		function class:AddActorCustomViaFileID(fileid,x,y,z,scale,yaw,pitch,roll,svk)
			local yaw=yaw or 0
			local pitch=pitch or 0
			local roll=roll or 0
			
			x=(x-self.centerx)
			y=(y-self.centery)
			z=(z-self.centerz)
			
			local xydist=math.sqrt(x*x+y*y)
			if(xydist>500)then return end

			
			a=self:AddActorByFileID(fileid,x*self.floorscale,y*self.floorscale,z*self.floorscale,scale*self.floorscale,yaw+self.floorrotation,pitch,roll)
			if(self.svk)then
				a:SetSpellVisualKit(self.svk)
			end
			return a
			
		end
	

		local function MultiplyQuaternions(r0,r1,r2,r3,s0,s1,s2,s3)
										-- W X Y Z
			return  r0*s0-r1*s1-r2*s2-r3*s3,
					r0*s1+r1*s0+r2*s3-r3*s2,
					r0*s2-r1*s3+r2*s0+r3*s1,
					r0*s3+r1*s2-r2*s1+r3*s0
		end		
		
		
	XPRACTICE_TEMP_OBJLIST={}
		
		--function class:AddActorCustomViaMPI_2(x,z,y,qX,qZ,qY,qW,scale,objtype,fileid)			
		function class:AddActorCustomViaMPI_2(x,z,y,qX,qY,qZ,qW,scale,objtype,fileid)					
			-- print("?",MultiplyQuaternions(0.707,0.707,0,0
										-- ,0.707,0,0,0.707))
			--print("initial y:",y)								
			y=-y+self.centery*2
			--print("flipped y:",y)

			if(XPRACTICE_TEMP_OBJLIST[tostring(x)..tostring(y)..tostring(z)..scale..fileid])then
				--print("WARNING: possible duplicate object(s) at",x,y,z,scale,fileid)				
				return
			end	
			XPRACTICE_TEMP_OBJLIST[tostring(x)..tostring(y)..tostring(z)..scale..fileid]=true			
			
			if(objtype=="m2")then
				
				--if(true)then return end --!!!!!
				local roll,pitch,yaw=qX*math.pi/180,qZ*math.pi/180,(qY-90)*math.pi/180
				local qW2,qX2,qY2,qZ2=EulerToQuat(roll,pitch,yaw)
				--local qW2,qX2,qY2,qZ2=qW,qX,qY,qZ
				a=self:AddActorCustomViaMPI(x,y,z,qW2,qX2,qY2,qZ2,scale,fileid)				
				return a			
			elseif(objtype=="wmo")then		
				--if(true)then return end  --!!!!!
				--if(fileid~=4256405)then return end --!!!!!
				--print("wmo",fileid)
				--local roll,pitch,yaw=QuatToEuler(qW,qX,qY,qZ)								
				--local roll,pitch,yaw=qX*math.pi/180,qY*math.pi/180,qZ*math.pi/180
				--local roll,pitch,yaw=qX*math.pi/180,qZ*math.pi/180,(qY-90)*math.pi/180
				local roll,pitch,yaw=qX*math.pi/180,qZ*math.pi/180,(qY-90)*math.pi/180
				--local roll,pitch,yaw=qX,qY,qZ-math.pi/2
				
				--yaw=yaw-math.pi/2
				--print("RPY:",roll*180/math.pi,pitch*180/math.pi,yaw*180/math.pi)		
				local qW2,qX2,qY2,qZ2=EulerToQuat(roll,pitch,yaw)
				--print("WMO quat",qW2,qX2,qY2,qZ2)				
				local mpi=XPRACTICE_mpi[fileid]
				if(mpi)then
					for i=1,#mpi do
						local obj=mpi[i]						
						local x2,y2,z2=XPRACTICE.MatrixMultiplicationRotation3(obj[1],obj[2],obj[3],roll,pitch,yaw)
						--local x2,y2,z2=obj[1],obj[2],obj[3]						
						x2=x2+x
						y2=y2+y
						z2=z2+z
						--print("xyz",x2-self.centerx,y2-self.centery,z2-self.centerz)

						local qW3,qX3,qY3,qZ3=MultiplyQuaternions(1,0,0,0,obj[4],obj[5],obj[6],obj[7])
						if(obj[9]==4222579)then --protobot
							--print("Send",qW3,qX3,qY3,qZ3)
						end
						self:AddActorCustomViaMPI(x2,y2,z2,qW3,qX3,qY3,qZ3,scale*obj[8],obj[9],roll,pitch,yaw)						
					end
				else
					print("WARNING: missing MPI",fileid)
				end
			end
		end
		
		
		function class:AddActorCustomViaMPI(x,y,z,qW,qX,qY,qZ,scale,fileid,extraroll,extrapitch,extrayaw)	
			--TODO: maybe MPI coordinates are also flipped and we never noticed because lihuvim's room is symmetrical?
			--TODO: also check for duplicate WMO placement across multiple ADTs!
			--TODO: check if we overlooked anything useful in adt's "ModelID"
							-- (but it looks like it's a unique tag for every single modelactor?)
				
			extraroll=extraroll or 0
			extrapitch=extrapitch or 0
			extrayaw=extrayaw or 0
			
			--local w2,x2,y2,z2=EulerToQuat(extraroll,extrapitch,extrayaw)			
			--print(w2,x2,y2,z2)
			
			--qW,qX,qY,qZ = qW,qX,-qZ,qY	-- We saved thousands of dollars by not hiring a mathematician for this.
			--print("WXYZ:",qW,qX,qY,qZ)
			local r1=2*(qW*qX+qY*qZ)
			local r2=1-2*(qX*qX+qY*qY)
			--local roll=math.atan2(2*(qW*qX+qY*qZ),1-2*(qX*qX+qY*qY))
			local roll=math.atan2(2*(qW*qX+qY*qZ),2*(qW*qW-qX*qX-qY*qY+qZ*qZ))
			local pitch
			local EDGECASE=false
			if(math.abs(2*(qW*qY-qZ*qX))>=1)then				
				pitch=math.pi/2*XPRACTICE.signum(2*(qW*qY-qZ*qX))
				EDGECASE=true				
			else
				pitch=math.asin(2*(qW*qY-qZ*qX))
			end			
			local yaw=math.atan2(2*(qW*qZ+qX*qY),1-2*(qY*qY+qZ*qZ))			
			
			--print("check",qW,qX,qY,qZ,roll,pitch,yaw)


			--roll,pitch,yaw=roll,yaw,pitch	-- (But honestly, we should have hired a mathematician for this.)
		
			if(true)then
				local w1,x1,y1,z1=EulerToQuat(roll,pitch,yaw)
				local w2,x2,y2,z2=EulerToQuat(extraroll,extrapitch,extrayaw)
				qW,qX,qY,qZ = MultiplyQuaternions(w2,x2,y2,z2,w1,x1,y1,z1)		
			
				local r1=2*(qW*qX+qY*qZ)
				local r2=1-2*(qX*qX+qY*qY)
				--local roll=math.atan2(2*(qW*qX+qY*qZ),1-2*(qX*qX+qY*qY))
				roll=math.atan2(2*(qW*qX+qY*qZ),2*(qW*qW-qX*qX-qY*qY+qZ*qZ))
				
				if(math.abs(2*(qW*qY-qZ*qX))>=1)then
					pitch=math.pi/2*XPRACTICE.signum(2*(qW*qY-qZ*qX))
				else
					pitch=math.asin(2*(qW*qY-qZ*qX))
				end			
				yaw=math.atan2(2*(qW*qZ+qX*qY),1-2*(qY*qY+qZ*qZ))	
			end
						
			--print("RPY:",roll,pitch,yaw)
						--!!!
			--print("fID:",fileid)
			if(fileid==4222579)then --protobot
				--print("MPI",fileid,x*self.floorscale,y*self.floorscale,z*self.floorscale,scale*self.floorscale,yaw+self.floorrotation,pitch,roll)
				--print("MPI",fileid,qW,qX,qY,qZ)
			end
			
			if(fileid==4267622 or fileid==3947587)then
				--if(z<-350 or z>-210)then return end
				--if(z<-1000 or z>-210)then return end
				--if(z<-2000 or z>-210)then return end
			end
			
	
			--print(self.centerx,self.centery,self.centerz)
			--print("floorrot:",self.floorrotation)
			a=self:AddActorCustomViaFileID(fileid,x,y,z,scale,yaw,pitch,roll)
			if(self.svk)then
				a:SetSpellVisualKit(self.svk)
			end
			--print("return",a)
			return a
		end		

		-- hexagon sides are 14root2
		local HEXside=14*math.sqrt(2)
		--local HEXhalfsideroot2=HEXside*.5*math.sqrt(2)
		local HEXtrianglediagonal = 7*math.sqrt(2)
		local HEXhalfsideroot3=HEXside*.5*math.sqrt(3)
		
		function class:AddActorCustom(class,x,y,z,scale,yaw,pitch,roll,svk)
			local scale=scale or 1
			local yaw=yaw or 0
			local pitch=pitch or 0			
			local roll=roll or 0
			x,y=XPRACTICE.Transform_Rotate2D(x,y,self.floorrotation,0,0)
			a=self:AddActorByClass(class,x*self.floorscale,y*self.floorscale,z*self.floorscale,scale*self.floorscale,yaw+self.floorrotation,pitch,roll)
			if(self.svk)then
				a:SetSpellVisualKit(self.svk)
			end
			return a
		end		
		
		function class:Hexagon(offsetx,offsety)
			self.svk=6524
			-- outer hex ring
			for i=0,5 do
				local a=math.pi*2/6*i+math.pi*0
				local x=offsetx+math.cos(a)*(HEXhalfsideroot3-14/math.sqrt(2))				
				local y=offsety+math.sin(a)*(HEXhalfsideroot3-14/math.sqrt(2))
				-- reminder: box sides are 14, not 14*root2.  adjust scale accordingly
				local boxscaleadjustment=(math.sqrt(2)+0.01)
				self:AddActorCustom(XPRACTICE.SOLIDS.Box001,x,y,-7*boxscaleadjustment,1*boxscaleadjustment,a+math.pi,math.pi/2)
			end
			---- inner hex fill
			--self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle001,offsetx+0,offsety+0,-1.45*1.5,1.5)
		end
		
		function class:HalfHexagon(offsetx,offsety)
			self.svk=6524
			-- outer hex ring, outer triangles
			for i=-1,1,2 do
				local a=math.pi*2/6*i+math.pi*0
				local x=offsetx+math.cos(a)*(HEXhalfsideroot3)
				local y=offsety+math.sin(a)*(HEXhalfsideroot3)
				self:AddActorCustom(XPRACTICE.SOLIDS.Ramp002,x,y,-7,1,a+math.pi/4,math.pi/2)
			end
			-- outer fill
			local boxscaleadjustment=(math.sqrt(2)+0.01)
			--a=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle002,offsetx+(HEXhalfsideroot3-0.5*14/math.sqrt(2)),offsety+0,-1.4*boxscaleadjustment,0.5*boxscaleadjustment)
			a=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle002,offsetx+(HEXhalfsideroot3-0.5*14/math.sqrt(2)),offsety+0,0.5*-1.45*boxscaleadjustment,0.5*boxscaleadjustment)
			-- halfway, inner triangles
			a=self:AddActorCustom(XPRACTICE.SOLIDS.Ramp002,offsetx,offsety+HEXside/2,-7,1,-math.pi*.75,math.pi/2)
			a=self:AddActorCustom(XPRACTICE.SOLIDS.Ramp002,offsetx,offsety-HEXside/2,-7,1,-math.pi*.75,math.pi/2)
			-- inner fill
			a=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle002,offsetx+7*.75,offsety+0,-1.45*.75,.75)
		end		
		
		--local rimheight=0.25
		local rimheight=0.25
		
		function class:HexagonRim(offsetx,offsety)
			local rimwidthmultiplier=0.25
			local rimwidth=HEXside*rimwidthmultiplier
			local boxscaleadjustment=(math.sqrt(2)+0.01)
			local rectanglescale=boxscaleadjustment
			local rectanglewidth=rectanglescale*2.8
			local inner=rectanglewidth*0.5
			
			
			
			self.svk=nil
			
			for i=0,5 do
				local a=math.pi*2/6*i
				local x=offsetx+(HEXhalfsideroot3-inner)*math.cos(a)
				local y=offsety+(HEXhalfsideroot3-inner)*math.sin(a)
				b=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle003Gray,x,y,(-55.5/2)*boxscaleadjustment+rimheight,rectanglescale,math.pi/2+a,0,math.pi/2)				
				
				--if(rimwidthmultiplier>???)then
				if(true)then
					local x=offsetx+(HEXhalfsideroot3-rimwidth+inner)*math.cos(a)
					local y=offsety+(HEXhalfsideroot3-rimwidth+inner)*math.sin(a)
					b=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle003Gray,x,y,(-55.5/2)*boxscaleadjustment+rimheight,rectanglescale,math.pi/2+a,0,math.pi/2)				
				end
			end			
		end
		
		function class:InnerEdge()
			local hexgridy=HEXside*1.5
			local hexgridx=HEXhalfsideroot3			
			local boxscaleadjustment=(math.sqrt(2)+0.01)
			local rectanglescale=boxscaleadjustment		
			local rectanglescale=boxscaleadjustment
			local rectanglewidth=rectanglescale*2.8
			self.svk=nil
			b=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle002Gray,hexgridx*2-rectanglewidth*.5,0,(-14/2)*boxscaleadjustment+rimheight,rectanglescale,0,math.pi/2,0)
			-- and luckily, rectangle002 is exactly 2 hexsides long
		end
		
		function class:OuterEdge()
			local hexgridy=HEXside*1.5
			local hexgridx=HEXhalfsideroot3
			
			local boxscaleadjustment=(math.sqrt(2)+0.01)
			local rectanglescale=boxscaleadjustment		
			local rectanglescale=boxscaleadjustment
			local rectanglewidth=rectanglescale*2.8
			self.svk=nil
			local min_=-2.412		-- not an exact value -- the correct number probably involves a sqrt somewhere
			local max_=2.412
			for j=0,2 do
				local i=min_+((max_-min_)*j/2)
				b=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle003Gray,hexgridx*11+rectanglewidth*.5,hexgridy*i,(-14/2)*boxscaleadjustment+rimheight,rectanglescale,0,math.pi/2,0)
				--rectangle003 is NOT exactly ???hexsides long but we cheat a tiny bit with the overlap
			end
		end	
			
		function class:WheelSpokes()
			local rimwidthmultiplier=0.25
			local rimwidth=HEXside*rimwidthmultiplier
			local boxscaleadjustment=(math.sqrt(2)+0.01)
			local rectanglescale=boxscaleadjustment
			local rectanglewidth=rectanglescale*2.8
			local inner=rectanglewidth*0.5
			self.svk=nil

			for j=0,2 do				
				for i=0,1 do
					b=self:AddActorCustom(XPRACTICE.SOLIDS.Rectangle003Gray,85+j*59+i*8,0,(-55.5/2)*boxscaleadjustment+rimheight-0.12,rectanglescale,0,0,math.pi/2)
				end
			end
		end	
						
			
		function class:Setup(environment,x,y,z)
			super.Setup(self,environment,x,y,z)

			local invrt2=1/math.sqrt(2)

			
			self.floorscale=1
			self.floorrotation=0
	
			
			-- --self:AddActorCustomViaExport(4267690,5.1,-.2,-8.7,2.3,1,0,0,0)
			
			-- self:AddActorCustomViaExport(4267690,0.0,-55.6,-8.7,2.3,0.5,0.5,-0.5,0.5)
			-- self:AddActorCustomViaExport(4267690,0.0,55.6,-8.7,2.3,0.5,-0.5,-0.5,-0.5)
			-- self:AddActorCustomViaExport(4267690,48.2,27.9,-8.7,2.3,-0.18,0.68,0.18,0.68)
			-- self:AddActorCustomViaExport(4267690,48.2,-27.8,-8.7,2.3,0.18,0.68,-0.18,0.68)		
			-- self:AddActorCustomViaExport(4267690,5.1,-.2,-8.7,2.3,-0.0,0.707,0,0.707)		-- 180 X, -90 Y
			

			-- ----38,37
			-- self.centerx=20600.0
			-- self.centery=19730.0
			-- self.centerz=200
			
			-- ----39,43
			-- self.centerx=21500.0
			-- self.centery=23500.0
			-- self.centerz=200
			
			-- ----34,39	-- (outdoors ZM)
			-- self.centerx=18500.0
			-- self.centery=21000.0
			-- self.centerz=50
			
			-- ----(37,38,39),40
			self.centerx=21211.0
			self.centery=23336.0	--TODO NEXT: setting centery >> 0 results in player initial position changing << 0 instead
											-- (almost certainly on account of the ADT y-flip)
									
			
			--self.centerz=-190
			--self.centerz=100
			self.centerz=90
			--self.centerz=1600
			
			
			
			--self.centery,self.centerz=self.centerz,self.centery
			
			XPRACTICE_TEMP_OBJLIST={}
			--local chunks={"39_43"}
			local chunks={}
						
			for i=1,#chunks do				
				local adt=XPRACTICE_adt["CHUNK_"..chunks[i]]
				--print(chunks[i])
				for i=1,#adt do
					self:AddActorCustomViaMPI_2(unpack(adt[i]))
				end
			end
			
			XPRACTICE_TEMP_OBJLIST={}
			
			-------------------------------------

			-- approx 165.67 yards between opposite points of the arena
			--self:AddActorByClass(XPRACTICE.SOLIDS.Box001Red,0,-165.67/2,0,0.1)
			--self:AddActorByClass(XPRACTICE.SOLIDS.Box001Red,0,165.67/2,0,0.1)
			
			self.centerx=0
			self.centery=0
			self.centerz=0
			self.floorscale=0.3725		--this number is sadly approximate
			self.floorrotation=0
			--!!!
			--self.floorrotation=math.pi*2/6*0.5
		

			local hexgridy=HEXside*1.5
			local hexgridx=HEXhalfsideroot3
			
		
			for i=0,5 do			
				self.floorrotation=i*math.pi*2/6
				self:Hexagon(0+hexgridx*1,0+hexgridy*3)
				self:Hexagon(0+hexgridx*1,0+hexgridy*5)
				self:Hexagon(0+hexgridx*2,0+hexgridy*2)
				self:Hexagon(0+hexgridx*2,0+hexgridy*4)
				self:Hexagon(0+hexgridx*2,0+hexgridy*6)
				self:Hexagon(0+hexgridx*4,0+hexgridy*2)
				self:Hexagon(0+hexgridx*4,0+hexgridy*4)
				self:Hexagon(0+hexgridx*5,0+hexgridy*3)
				self:Hexagon(0+hexgridx*5,0+hexgridy*5)
				self:Hexagon(0+hexgridx*7,0+hexgridy*3)
				self:Hexagon(0+hexgridx*8,0+hexgridy*4)
			end
			
			-- note -- these halves are not connected to (or even rotated correctly for) the corner we just filled in
			for i=0,5 do
				self.floorrotation=i*math.pi*2/6
				self:HalfHexagon(0+hexgridx*2,0)
				self:HalfHexagon(0+hexgridx*-11,0+hexgridy*3)
				self:HalfHexagon(0+hexgridx*-11,0+hexgridy*1)
				self:HalfHexagon(0+hexgridx*-11,0-hexgridy*1)
				self:HalfHexagon(0+hexgridx*-11,0-hexgridy*3)			
			end
			
			for i=0,5 do
				self.floorrotation=i*math.pi*2/6
				self:HexagonRim(0+hexgridx*3,0+hexgridy*1)
				self:HexagonRim(0+hexgridx*3,0+hexgridy*3)
				self:HexagonRim(0+hexgridx*3,0+hexgridy*5)
				self:HexagonRim(0+hexgridx*6,0+hexgridy*2)
				self:HexagonRim(0+hexgridx*6,0+hexgridy*4)
				self:HexagonRim(0+hexgridx*9,0+hexgridy*3)
			end
			
			for i=0,5 do
				self.floorrotation=i*math.pi*2/6
				self:InnerEdge()
			end
			
			for i=0,5 do
				self.floorrotation=i*math.pi*2/6
				self:OuterEdge()
			end
			
			for i=0,5 do
				self.floorrotation=i*math.pi*2/6+math.pi*1/6
				self:WheelSpokes()
			end
			
			local a=self:AddActorByClass(XPRACTICE.THEJAILER2.AzerothPlanet2,0,0,45,9)
			a:SetAnimation(158)
			--a:SetAlpha(0.5)




			
		end
	end
	

end

do
	local super=XPRACTICE.WoWObject
	XPRACTICE.THEJAILER2.AzerothPlanet2=XPRACTICE.inheritsFrom(super)
	local class=XPRACTICE.THEJAILER2.AzerothPlanet2
	
	function class:SetActorAppearanceViaOwner(actor)
		--actor:SetModelByFileID(4324610)	--9du_progenitorraid_jailerfight_azerothglobe01
		actor:SetModelByFileID(4284022)		--9fx_raid3_jailer_azeritepillar
	end
	-- function class:SetDefaultAnimation()
		-- self.animationmodule:PlayAnimation(XPRACTICE.AnimationList.ProjectileLoopCustomDuration)
		-- self.projectilespawncustomduration=1.0
		-- self.projectileloopcustomduration=nil
		-- self.projectiledespawncustomduration=1.0
	-- end			
end

do
XPRACTICE_mpi={}
XPRACTICE_adt={}

-- super-top-secret tech redacted


end